/*
 * Copyright 2010-2015 JetBrains s.r.o.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.jetbrains.kotlin.completion;

import com.intellij.testFramework.TestDataPath;
import org.jetbrains.kotlin.test.InnerTestClasses;
import org.jetbrains.kotlin.test.JUnit3RunnerWithInners;
import org.jetbrains.kotlin.test.JetTestUtils;
import org.jetbrains.kotlin.test.TestMetadata;
import org.junit.runner.RunWith;

import java.io.File;
import java.util.regex.Pattern;

/** This class is generated by {@link org.jetbrains.kotlin.generators.tests.TestsPackage}. DO NOT MODIFY MANUALLY */
@SuppressWarnings("all")
@TestMetadata("idea/testData/completion/basic/multifile")
@TestDataPath("$PROJECT_ROOT")
@RunWith(JUnit3RunnerWithInners.class)
public class MultiFileJvmBasicCompletionTestGenerated extends AbstractMultiFileJvmBasicCompletionTest {
    public void testAllFilesPresentInMultifile() throws Exception {
        JetTestUtils.assertAllTestsPresentByMetadata(this.getClass(), new File("idea/testData/completion/basic/multifile"), Pattern.compile("^([^\\.]+)$"), false);
    }

    @TestMetadata("CompleteFunctionWithNoSpecifiedType")
    public void testCompleteFunctionWithNoSpecifiedType() throws Exception {
        String fileName = JetTestUtils.navigationMetadata("idea/testData/completion/basic/multifile/CompleteFunctionWithNoSpecifiedType/");
        doTest(fileName);
    }

    @TestMetadata("CompleteImportedFunction")
    public void testCompleteImportedFunction() throws Exception {
        String fileName = JetTestUtils.navigationMetadata("idea/testData/completion/basic/multifile/CompleteImportedFunction/");
        doTest(fileName);
    }

    @TestMetadata("CompletionOnImportedFunction")
    public void testCompletionOnImportedFunction() throws Exception {
        String fileName = JetTestUtils.navigationMetadata("idea/testData/completion/basic/multifile/CompletionOnImportedFunction/");
        doTest(fileName);
    }

    @TestMetadata("DoNotCompleteWithConstraints")
    public void testDoNotCompleteWithConstraints() throws Exception {
        String fileName = JetTestUtils.navigationMetadata("idea/testData/completion/basic/multifile/DoNotCompleteWithConstraints/");
        doTest(fileName);
    }

    @TestMetadata("EnumEntry")
    public void testEnumEntry() throws Exception {
        String fileName = JetTestUtils.navigationMetadata("idea/testData/completion/basic/multifile/EnumEntry/");
        doTest(fileName);
    }

    @TestMetadata("ExtensionFunction")
    public void testExtensionFunction() throws Exception {
        String fileName = JetTestUtils.navigationMetadata("idea/testData/completion/basic/multifile/ExtensionFunction/");
        doTest(fileName);
    }

    @TestMetadata("ExtensionFunctionOnImportedFunction")
    public void testExtensionFunctionOnImportedFunction() throws Exception {
        String fileName = JetTestUtils.navigationMetadata("idea/testData/completion/basic/multifile/ExtensionFunctionOnImportedFunction/");
        doTest(fileName);
    }

    @TestMetadata("ExtensionOnNullable")
    public void testExtensionOnNullable() throws Exception {
        String fileName = JetTestUtils.navigationMetadata("idea/testData/completion/basic/multifile/ExtensionOnNullable/");
        doTest(fileName);
    }

    @TestMetadata("ExtensionsForSmartCast")
    public void testExtensionsForSmartCast() throws Exception {
        String fileName = JetTestUtils.navigationMetadata("idea/testData/completion/basic/multifile/ExtensionsForSmartCast/");
        doTest(fileName);
    }

    @TestMetadata("GroovyClassNameCompletionFromDefaultPackage")
    public void testGroovyClassNameCompletionFromDefaultPackage() throws Exception {
        String fileName = JetTestUtils.navigationMetadata("idea/testData/completion/basic/multifile/GroovyClassNameCompletionFromDefaultPackage/");
        doTest(fileName);
    }

    @TestMetadata("GroovyClassNameCompletionFromNonDefaultPackage")
    public void testGroovyClassNameCompletionFromNonDefaultPackage() throws Exception {
        String fileName = JetTestUtils.navigationMetadata("idea/testData/completion/basic/multifile/GroovyClassNameCompletionFromNonDefaultPackage/");
        doTest(fileName);
    }

    @TestMetadata("InImportedFunctionLiteralParameter")
    public void testInImportedFunctionLiteralParameter() throws Exception {
        String fileName = JetTestUtils.navigationMetadata("idea/testData/completion/basic/multifile/InImportedFunctionLiteralParameter/");
        doTest(fileName);
    }

    @TestMetadata("JavaInnerClasses")
    public void testJavaInnerClasses() throws Exception {
        String fileName = JetTestUtils.navigationMetadata("idea/testData/completion/basic/multifile/JavaInnerClasses/");
        doTest(fileName);
    }

    @TestMetadata("NoAutoInsertionOfNotImported")
    public void testNoAutoInsertionOfNotImported() throws Exception {
        String fileName = JetTestUtils.navigationMetadata("idea/testData/completion/basic/multifile/NoAutoInsertionOfNotImported/");
        doTest(fileName);
    }

    @TestMetadata("NoExtForOuterFromNested")
    public void testNoExtForOuterFromNested() throws Exception {
        String fileName = JetTestUtils.navigationMetadata("idea/testData/completion/basic/multifile/NoExtForOuterFromNested/");
        doTest(fileName);
    }

    @TestMetadata("NoExtensionMethodDuplication")
    public void testNoExtensionMethodDuplication() throws Exception {
        String fileName = JetTestUtils.navigationMetadata("idea/testData/completion/basic/multifile/NoExtensionMethodDuplication/");
        doTest(fileName);
    }

    @TestMetadata("NotImportedExtensionForImplicitReceiver")
    public void testNotImportedExtensionForImplicitReceiver() throws Exception {
        String fileName = JetTestUtils.navigationMetadata("idea/testData/completion/basic/multifile/NotImportedExtensionForImplicitReceiver/");
        doTest(fileName);
    }

    @TestMetadata("NotImportedExtensionFunction")
    public void testNotImportedExtensionFunction() throws Exception {
        String fileName = JetTestUtils.navigationMetadata("idea/testData/completion/basic/multifile/NotImportedExtensionFunction/");
        doTest(fileName);
    }

    @TestMetadata("NotImportedExtensionProperty")
    public void testNotImportedExtensionProperty() throws Exception {
        String fileName = JetTestUtils.navigationMetadata("idea/testData/completion/basic/multifile/NotImportedExtensionProperty/");
        doTest(fileName);
    }

    @TestMetadata("NotImportedFunction")
    public void testNotImportedFunction() throws Exception {
        String fileName = JetTestUtils.navigationMetadata("idea/testData/completion/basic/multifile/NotImportedFunction/");
        doTest(fileName);
    }

    @TestMetadata("NotImportedInfixExtension")
    public void testNotImportedInfixExtension() throws Exception {
        String fileName = JetTestUtils.navigationMetadata("idea/testData/completion/basic/multifile/NotImportedInfixExtension/");
        doTest(fileName);
    }

    @TestMetadata("NotImportedJavaClass")
    public void testNotImportedJavaClass() throws Exception {
        String fileName = JetTestUtils.navigationMetadata("idea/testData/completion/basic/multifile/NotImportedJavaClass/");
        doTest(fileName);
    }

    @TestMetadata("NotImportedObject")
    public void testNotImportedObject() throws Exception {
        String fileName = JetTestUtils.navigationMetadata("idea/testData/completion/basic/multifile/NotImportedObject/");
        doTest(fileName);
    }

    @TestMetadata("NotImportedProperty")
    public void testNotImportedProperty() throws Exception {
        String fileName = JetTestUtils.navigationMetadata("idea/testData/completion/basic/multifile/NotImportedProperty/");
        doTest(fileName);
    }

    @TestMetadata("ObjectInTypePosition")
    public void testObjectInTypePosition() throws Exception {
        String fileName = JetTestUtils.navigationMetadata("idea/testData/completion/basic/multifile/ObjectInTypePosition/");
        doTest(fileName);
    }

    @TestMetadata("TopLevelFunction")
    public void testTopLevelFunction() throws Exception {
        String fileName = JetTestUtils.navigationMetadata("idea/testData/completion/basic/multifile/TopLevelFunction/");
        doTest(fileName);
    }
}
